opensaml::SOAPClient Class Reference

Specialized SOAPClient for SAML SOAP bindings. More...

`#include <saml/binding/SOAPClient.h>`

Inheritance diagram for opensaml::SOAPClient:
[legend]
Collaboration diagram for opensaml::SOAPClient:
[legend]

## Public Member Functions

| SOAPClient (SecurityPolicy &policy)
| Creates a SOAP client instance with a particular SecurityPolicy.
void | forceTransportAuthentication (bool force=true)
| Controls whether to force transport/peer authentication via an X509TrustEngine.
virtual void | send (const soap11::Envelope &env, const char *from, saml2md::MetadataCredentialCriteria &to, const char *endpoint)
| SAML-specific method uses metadata to determine the peer name and prepare the transport layer with peer credential information.
soap11::Envelope * | receive ()
| Override applies SecurityPolicy to envelope before returning it.
void | reset ()
SecurityPolicy & | getPolicy () const
| Returns the SecurityPolicy supplied to the client.

## Protected Member Functions

void | prepareTransport (xmltooling::SOAPTransport &transport)
| Override prepares transport by assigning an X509TrustEngine to it, if one is attached to the policy.

## Protected Attributes

SecurityPolicy & | m_policy
| Reference to security policy to apply.
bool | m_force
| Flag controlling whether transport/peer authn is mandatory.
const saml2md::RoleDescriptor * | m_peer
| Metadata-based peer identity.
saml2md::MetadataCredentialCriteria * | m_criteria
| Metadata-based CredentialCriteria for supplying credentials to TrustEngine.

## Detailed Description

Specialized SOAPClient for SAML SOAP bindings.

## Constructor & Destructor Documentation

## SOAPClient()

opensaml::SOAPClient::SOAPClient | ( | SecurityPolicy & | policy | ) |

Creates a SOAP client instance with a particular SecurityPolicy.

Parameters

  policy | reference to SecurityPolicy to apply

## Member Function Documentation

## forceTransportAuthentication()

void opensaml::SOAPClient::forceTransportAuthentication | ( | bool | force = true | ) |

Controls whether to force transport/peer authentication via an X509TrustEngine.

Only makes sense if an X509TrustEngine is supplied by the SecurityPolicy.

Parameters

  force | true iff the client should refuse to communicate without this protection

## getPolicy()

SecurityPolicy & opensaml::SOAPClient::getPolicy | ( |  | ) | const

Returns the SecurityPolicy supplied to the client.

Returns
  the associated SecurityPolicy

## prepareTransport()

void opensaml::SOAPClient::prepareTransport | ( | xmltooling::SOAPTransport & | transport | ) |

protected

Override prepares transport by assigning an X509TrustEngine to it, if one is attached to the policy.

Parameters

  transport | reference to transport layer

## receive()

soap11::Envelope * opensaml::SOAPClient::receive | ( |  | ) |

Override applies SecurityPolicy to envelope before returning it.

Returns
  response envelope after SecurityPolicy has been applied

## send()

virtual void opensaml::SOAPClient::send | ( | const soap11::Envelope & | env,
|  | const char * | from,
|  | saml2md::MetadataCredentialCriteria & | to,
|  | const char * | endpoint )

virtual

SAML-specific method uses metadata to determine the peer name and prepare the transport layer with peer credential information.

The SecurityPolicy is also reset, in case the policy is reused.

Parameters

  env | SOAP envelope to send
  from | identity of sending application
  to | peer to send message to, expressed in metadata criteria terms
  endpoint | URL of endpoint to recieve message

The documentation for this class was generated from the following file:

- saml/binding/SOAPClient.h